/*###################################### 
# Fichier : Damier.cpp
# Fait par Fernandez Stephane 07 219 609
# Projet de session ift630
######################################*/

#include "Damier.h"

/* Constructeur
In : int->Dimension du damier
Out : Damier */
Damier::Damier(int nbElement){
       Espace=new int[nbElement];
       ArraySize=nbElement;
       NbPossibilite=(int)pow(ArraySize,ArraySize);
       for(int i=0;i<ArraySize;i++)Espace[i]=0;
}

int Damier::GetNbPossibilite(){return NbPossibilite;}

/* Increase
In : int->rang avec lequel elle est appel
(fonction recursive)
Out : int->-1, erreur
         -> 1, nouvelle combinaison gnre
         -> 0, derniere combinaison gnre*/
int Damier::Increase(int rang){
       if(rang >= ArraySize)return -1;
       if(rang == ArraySize-1 && Espace[rang]==ArraySize-1){return 0;}
       if(Espace[rang]<ArraySize-1) {
                   Espace[rang]++;
                   return 1;
       }
       if(Espace[rang] == ArraySize-1){
				   Espace[rang]=0;
				   rang++;
				   return Increase(rang);
       }
}

/* IncreaseParallele
Meme fonctionnement que Increase
avec une entre supplmentaire :
	 int->Position de la dame fixe*/
int Damier::IncreaseParallele(int rang,int numero){
       if(rang >= ArraySize)return -1;
       if(rang == ArraySize-2 && Espace[rang]==ArraySize-1){Espace[ArraySize-1]=numero;return 0;}
       if(Espace[rang]<ArraySize-1) {
                   Espace[rang]++;
                   Espace[ArraySize-1]=numero;
                   return 1;
       }
       if(Espace[rang] == ArraySize-1){
				   Espace[rang]=0;
				   rang++;
				   return IncreaseParallele(rang,numero);
       }
}

/* Affiche
In : void
Out : void
Affiche un damier*/
void Damier::Affiche(){
	 for(int i=0;i<ArraySize;i++)printf("%d ",Espace[i]);
	 printf("\n");
}

/* GetEspace
In : void
Out : *int->renvoi le tableau Espace de Damier*/
int* Damier::GetEspace(){return Espace;}

